#include <complex>
#include "MMatrix.h"  //Contains library to handle quickly matrices in memory
#define Complex  std::complex<double>

/* See m_matrix.cpp file for details on procedures */

void show(MMatrix<double>);
void show(MMatrix<int>);
void show(MMatrix<Complex>);
void show(MMatrix<double>,char*);

MMatrix<double>& invertNonZeroElements(MMatrix<double>& M); //inverts each non-zero element of M and replaces it in M. Zero elements are left 0. Another reference to M is returned for convenience.
MMatrix<double> inverse_elements(MMatrix<double>);
MMatrix<double> transpose(MMatrix<double>);
MMatrix<double> transpose2(MMatrix<double>);	
double  scalar_product(MMatrix<double>,MMatrix<double>);
//template<typename T>
//bool iselement(MMatrix<T>,<T>);

/* These procedures can always be improved */
MMatrix<double> multiply(MMatrix<double>,MMatrix<double>);
void mult(MMatrix<double>&,MMatrix<double>);
Complex determinant3x3(MMatrix<Complex>);
double determinant3x3(MMatrix<double> M);
double spectral_radius(MMatrix<double>);




