#ifndef PLOTTING_H //inclusion guard
#define PLOTTING_H

#include <string>
#include <vector>
#include "Polygon.h"
#include "plot_util.h"
#include "xyzFileSave.h" //for Vector3
using namespace std;


void drawPolygon(Polygon pg);
void draw(Circle aCircle);


void sixcolourplot(double var, double cd1, double cd2, double a1, double a2, double a3, double a4, double a5);


/**
* Plots the points in the given vector across the x,y plane with the colour of the points 
* determined by the z value. 
* Points are in 6 colour bands evenly spread across the range of z values.
* Some details of the points and a key to the colour bands is printed to standard output.
*/
void autoSixColourPlot(vector<Vector3> results);
/**
 * Plots a crude contour plot across the x,y plane from the points in the given vector. 
 * Only points near a determined contour value are plotted.
 * Some details of the points and a key to the contours is printed to standard output.
 * The higher the contour number the redder it is.
 */
void simpleContourPlot(vector<Vector3> results, int numContours);
/**
 * Plots a point if the value given is close enough to any of the contour line values
 * @param var property of point to test for closeness to contour lines
 * @param x1 x coordinate of point to plot
 * @param x2 y coordinate of point to plot
 * @param tolerance how close var must be to a contour value
 * @param contours values of each of the contour "lines"
 */
void simpleContourPlotPoint(double var, double x1, double x2, double tolerance, const vector<double> & contours);



#endif //PLOTTING_H
